# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::PrivateDns::Mgmt::V2018_09_01
  module Models
    #
    # Describes a link to virtual network for a Private DNS zone.
    #
    class VirtualNetworkLink < TrackedResource

      include MsRestAzure

      # @return [String] The ETag of the virtual network link.
      attr_accessor :etag

      # @return [SubResource] The reference of the virtual network.
      attr_accessor :virtual_network

      # @return [Boolean] Is auto-registration of virtual machine records in
      # the virtual network in the Private DNS zone enabled?
      attr_accessor :registration_enabled

      # @return [VirtualNetworkLinkState] The status of the virtual network
      # link to the Private DNS zone. Possible values are 'InProgress' and
      # 'Done'. This is a read-only property and any attempt to set this value
      # will be ignored. Possible values include: 'InProgress', 'Completed'
      attr_accessor :virtual_network_link_state

      # @return [ProvisioningState] The provisioning state of the resource.
      # This is a read-only property and any attempt to set this value will be
      # ignored. Possible values include: 'Creating', 'Updating', 'Deleting',
      # 'Succeeded', 'Failed', 'Canceled'
      attr_accessor :provisioning_state


      #
      # Mapper for VirtualNetworkLink class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VirtualNetworkLink',
          type: {
            name: 'Composite',
            class_name: 'VirtualNetworkLink',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              virtual_network: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.virtualNetwork',
                type: {
                  name: 'Composite',
                  class_name: 'SubResource'
                }
              },
              registration_enabled: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.registrationEnabled',
                type: {
                  name: 'Boolean'
                }
              },
              virtual_network_link_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.virtualNetworkLinkState',
                type: {
                  name: 'String'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
